namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "speed_swap")]
public class SpeedSwap : Script, IScriptOnSecondaryEffect
{
    /// <inheritdoc />
    public void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        var userSpeed = move.User.FlatStats.Speed;
        var targetSpeed = target.FlatStats.Speed;

        move.User.FlatStats.SetStatistic(Statistic.Speed, targetSpeed);
        target.FlatStats.SetStatistic(Statistic.Speed, userSpeed);
        move.User.RecalculateBoostedStats();
        target.RecalculateBoostedStats();
    }
}